function AddSequence(){
	var indecies = [];
			
	//		SingleStand
	//================================================================================================================
	function addSingleStandClick(){
		$("#SAddButton").click(function(){
			$(".warnning").remove();
			if(checkEmptiness($("#Smistakes"), $("#Spattern")) || indecies.length < 1){
				return;
			}else if(checkInsertion($("#SinsertionNumber"), $("#SinsertionLetter"))){
				return;
			}
			
			var index = min(indecies);
			var mistakes = parseInt($("#Smistakes").val());
			var pattern = $("#Spattern").val().toUpperCase();
			var insertionNum = parseInt($("#SinsertionNumber").val());
			var insertionLetter = $("#SinsertionLetter").val().toUpperCase();
			var last =  rnaStructure.lastIndex("s", index);
			var s = new SequenceClass("s" + last, mistakes, pattern);
			s.setInsertion(insertionNum, insertionLetter);
			rnaStructure.addSingleStand(last, index, s);
			sequenceWasAdded();
		});
	}	
	addSingleStandClick();
	
	//		Helix
	//================================================================================================================
	function addHelixClick(){
		$("#HAddButton").click(function(){
			$(".warnning").remove();
			if(checkEmptiness($("#Hmistakes1"), $("#Hpattern1")) || checkEmptiness($("#Hmistakes2"), $("#Hpattern2"))){  
				return;
			}else if(checkPairOrder($("#Hpattern1"), $("#Hpattern2"))){
				return;
			}else if(checkInsertion($("#HinsertionNumber"), $("#HinsertionLetter"))){
				return;
			}
			
			var index1 = min(indecies);
			var index2 = max(indecies);
			var mistakes1 = parseInt($("#Hmistakes1").val());
			var mistakes2 =  parseInt($("#Hmistakes2").val());
			var pattern1 = $("#Hpattern1").val().toUpperCase();
			var pattern2 = $("#Hpattern2").val().toUpperCase();
			var insertionNum = parseInt($("#HinsertionNumber").val());
			var insertionLetter = $("#HinsertionLetter").val().toUpperCase();
			var last = rnaStructure.lastIndex("h", index1);
			var h1 = new SequenceClass("h"+last, mistakes1, pattern1);
			var h2 = new SequenceClass("h"+last+"'", mistakes2, pattern2);
			h1.setPair(h2);
			h2.setPair(h1);
			h1.setInsertion(insertionNum, insertionLetter);
			rnaStructure.addHelix(last, index1, index2, h1, h2);
			sequenceWasAdded();
		});
	}
	addHelixClick();
	
	//		Relation
	//================================================================================================================
	function addRelationClick(){
		$("#RAddButton").click(function(){
			$(".warnning").remove();
			if(checkEmptiness($("#Rmistakes1"), $("#Rpattern1")) || checkEmptiness($("#Rmistakes2"), $("#Rpattern2"))){  
				return;
			}else if(checkPairOrder($("#Rpattern1"), $("#Rpattern2"))){
				return;
			}else if(checkAlphabet($("#Ralphabet"))){
				return;
			}else if(checkInsertion($("#RinsertionNumber"), $("#RinsertionLetter"))){
				return;
			}
			
			var index1 = min(indecies);
			var index2 = max(indecies);
			var mistakes1 = parseInt($("#Rmistakes1").val());
			var mistakes2 =  parseInt($("#Rmistakes2").val());
			var pattern1 = $("#Rpattern1").val().toUpperCase();
			var pattern2 = $("#Rpattern2").val().toUpperCase();
			var alphabet = $("#Ralphabet").val().toUpperCase();
			var insertionNum = parseInt($("#RinsertionNumber").val());
			var insertionLetter = $("#RinsertionLetter").val().toUpperCase();
			var last = rnaStructure.lastIndex("r", index1);
			var r1 = new SequenceClass("r"+last, mistakes1, pattern1);
			var r2 = new SequenceClass("r"+last+"'", mistakes2, pattern2);
			r1.setPair(r2);
			r2.setPair(r1);
			r1.setRule(alphabet);
			r2.setRule(alphabet);
			r1.setInsertion(insertionNum, insertionLetter);
			rnaStructure.addRelation(last, index1, index2, r1, r2);
			sequenceWasAdded();
		});
	}
	addRelationClick();
	
	//=================================================================================================================	
	clickOnDash = function(){
		$("#whole-RNA").on("click", "div.dash", function(){
			$('#tab').tabs("option", "active", 1);
			colors.setColor(null, null);
			$(".element, .dash").each(function(i) {
				if($(this).hasClass("selected")) {
					$(this).removeClass("selected");
				}
			});
			
			i = $(".dash").index(this);
			if(indecies.indexOf(i) !== -1){
				var ix = indecies.indexOf(i)
				indecies.splice(ix, 1);
			}else{
				indecies.push(i);
			}
			if(indecies.length > 2){
				indecies.shift();
			}
			var dashes = $(".dash").toArray();
			for(var ix = 0; ix < indecies.length; ix++){
				$(dashes[indecies[ix]]).addClass("selected");
			}
			
			var j = min(indecies);
			if(indecies.length === 0){
				$("#add-sequence").hide();
				return;
			}
			$("#sequence-details").hide();
			$("#add-sequence").show();
			$("#Sname").text("s" + rnaStructure.lastIndex("s", j));
			var jx = rnaStructure.lastIndex("h", j);
			$("#Hname1").text("h" + jx);
			$("#Hname2").text("h" + jx + "'");
			$("#Rname1").text("r" + jx);
			$("#Rname2").text("r" + jx + "'");
		});
	}
	clickOnDash(); 
	
	function sequenceWasAdded(){
		$("#add-sequence").hide();
		indecies = [];
		clearImputs();
	}
	
	function min(array){
		var min = "none";
		for(var i = 0; i < array.length; i++){
			if(min > array[i] || min === "none"){
				min = array[i];
			}
		}
		return min;
	}
	
	function max(array){
		var max = "none";
		for(var i = 0; i < array.length; i++){
			if(max < array[i] || max === "none"){
				max = array[i];
			}
		}
		return max;	
	}

	clearImputs = function(){
		$(".warnning").remove();
		$("#Smistakes").val("");
		$("#Spattern").val("");
		$("#SinsertionNumber").val("0");
		$("#SinsertionLetter").val("");
		$("#Hmistakes1").val("");
		$("#Hmistakes2").val("");
		$("#Hpattern1").val("");
		$("#Hpattern2").val("");
		$("#HinsertionNumber").val("0");
		$("#HinsertionLetter").val("");
		$("#Rmistakes1").val("");
		$("#Rmistakes2").val("");
		$("#Rpattern1").val("");
		$("#Rpattern2").val("");
		$("#Ralphabet").val("");
		$("#RinsertionNumber").val("0");
		$("#RinsertionLetter").val("");
	}
}
 